PROGRAM JUEGO_DE_LA_OCA;


USES

    crt; {Unidad que contiene las siguiente funciones que utilizaremos:
          - CLRSCR (borra la pantalla)
          - GOTOXY (situa el cursor en las coordenadas que le indiquemos)
          - TEXTCOLOR (cambia el color del texto que se escriba a continuacion,
            las constantes para los colores tambien estan definidas en esta
            unidad}


CONST

    {Casillas inicial y final del tablero, y tambien las especiales}
    CASILLA_INICIAL = 0;
    PUENTE_1 = 6;
    PUENTE_2 = 12;
    OCA_1 = 5;
    OCA_2 = 9;
    OCA_3 = 14;
    OCA_4 = 18;
    OCA_5 = 23;
    CASILLA_FINAL = 27;

    {El numero de caras que tiene el dado}
    CARAS_DADO = 6;

    {Los colores}
    COLOR_INICIO_FIN = YELLOW;
    COLOR_OCAS = WHITE;
    COLOR_PUENTES = GREEN;
    COLOR_POSADA = BROWN;
    COLOR_CALAVERA = MAGENTA;
    COLOR_TEXTO = LIGHTGRAY;
    COLOR_JUGADOR = BLUE;
    COLOR_MAQUINA = RED;

    {Los simbolos que representan las fichas}
    FICHA_JUGADOR = 'O';
    FICHA_MAQUINA = 'X';


{------------------------------------------------------------------------------}


FUNCTION tirada : integer;
{Esta funcion devuelve un entero pseudoaleatorio entre 1 y el numero de caras
 del dado, simulando un lanzamiento del dado}


BEGIN

    tirada := random(CARAS_DADO) + 1;

END;


{------------------------------------------------------------------------------}


PROCEDURE oca(VAR posicion : integer;
              VAR turnosRestantes : integer);
{Este procedimiento indica que se ha caido en una casilla oca, mueve a la
 siguiente oca y da otro turno al jugador}


BEGIN

    writeln('una oca (casilla ', posicion, ').');
    writeln('De oca a oca y tiro porque me toca.');

    CASE posicion OF

        OCA_1 : posicion := OCA_2;
        OCA_2 : posicion := OCA_3;
        OCA_3 : posicion := OCA_4;
        OCA_4 : posicion := OCA_5;
        OCA_5 : posicion := CASILLA_FINAL;

    END;

    inc(turnosRestantes);

END;


{------------------------------------------------------------------------------}


PROCEDURE puente(VAR posicion : integer;
                 VAR turnosRestantes : integer;
                 casillaPosada : integer);
{Este procedimiento indica que se ha caido en un puente, mueve la ficha a la
 posada y hace que el jugador pierda un turno}


BEGIN

    writeln('un puente (casilla ', posicion, ').');
    writeln('La ficha se mueve a la posada y se pierde un turno.');

    posicion := casillaPosada;
    turnosRestantes := -1;

END;


{------------------------------------------------------------------------------}


PROCEDURE posada(posicion : integer;
                 VAR turnosRestantes : integer);
{Este procedimiento indica que se ha caido en la posada y hace que el jugador
 pierda un turno}


BEGIN

    writeln('la posada (casilla ', posicion, ').');
    writeln('El jugador que cae en la posada pierde un turno.');
    dec(turnosRestantes);

END;


{------------------------------------------------------------------------------}


PROCEDURE calavera(VAR posicion : integer);
{Este procedimiento indica que se ha caido en la calavera y mueve la ficha a la
 casilla 1}


BEGIN

    writeln('la calavera (casilla ', posicion, ').');
    writeln('El jugador que ha caido en la calavera vuelve a la casilla 1.');

    posicion := 1;

END;


{------------------------------------------------------------------------------}


PROCEDURE ultimaCasilla(posicion : integer;
                        VAR turnosRestantes : integer);
{Este procedimiento indica que se ha caido en el jardin de la oca y hace que no
 queden turnos restantes}


BEGIN

    write('el jardin de la oca (casilla ', posicion, ').');
    turnosRestantes := 0;

END;

{------------------------------------------------------------------------------}


PROCEDURE muestraTablero;
{Esta funcion muestra el tablero del juego con los numeros de las casillas}


BEGIN

    clrscr;
    writeln('       _______ _______ _______ _______ _______ _______ _______ _______ _______');
    writeln('      |      1|      2|      3|      4|      5|      6|      7|      8|      9|');
    writeln('      |       |       |       |       |       |       |       |       |       |');
    writeln('      |       |       |       |       |       |       |       |       |       |');
    writeln('      |_______|_______|_______|_______|_______|_______|_______|_______|_______|');
    writeln('                                                                      |     10|');
    writeln('                                       _______________________        |       |');
    writeln('                                      |                     27|       |       |');
    writeln('       _______ _______ _______ _______|                       |       |_______|');
    writeln('      |     23|     24|     25|     26|                       |       |     11|');
    writeln('      |       |       |       |       |                       |       |       |');
    writeln('      |       |       |       |       |                       |       |       |');
    writeln('      |_______|_______|_______|_______|                       |       |_______|');
    writeln('      |     22|                       |                       |       |     12|');
    writeln('      |       |                       |_______________________|       |       |');
    writeln('      |       |                                                       |       |');
    writeln('      |_______|_______ _______________________ _______________ _______|_______|');
    writeln('      |     21|     20|     19|     18|     17|     16|     15|     14|     13|');
    writeln('      |       |       |       |       |       |       |       |       |       |');
    writeln('      |       |       |       |       |       |       |       |       |       |');
    writeln('      |_______|_______|_______|_______|_______|_______|_______|_______|_______|');

END;


{------------------------------------------------------------------------------}


PROCEDURE colocaCursorEnCasilla(casilla : integer;
                                posicionDentroDeCasilla : integer);
{Esta funcion coloca el cursor en las coordenadas adecuadas para mostrar las
 fichas o el texto en una determinada casilla. posicionDentroDeCasilla puede
 valer 1 (se refiere a la linea inferior de la casilla, donde se escribira su
 nombre, en caso de ser una casilla especial), 2 (se refiere a la posicion donde
 se mostrara la ficha del jugador 1) o 3 (se refiere a la posicion donde se
 mostrara la ficha del jugador 2, distinta de la del jugador 1 por si los dos
 estan en la misma casilla)}


VAR

    x : integer;
    y : integer;


BEGIN

    CASE casilla OF

        {Estas coordenadas las sacamos fijandonos en la funcion anterior, donde
         queremos cada cosa. Por defecto, nos lleva a la esquina inferior
         izquierda de la casilla (donde imprimimos el nombre de la casilla)}
        0 : BEGIN x:= 1; y := 4; END;
        1 : BEGIN x := 8; y := 4; END;
        2 : BEGIN x := 16; y := 4; END;
        3 : BEGIN x := 24; y := 4; END;
        4 : BEGIN x := 32; y := 4; END;
        5 : BEGIN x := 40; y := 4; END;
        6 : BEGIN x := 48; y := 4; END;
        7 : BEGIN x := 56; y := 4; END;
        8 : BEGIN x := 64; y := 4; END;
        9 : BEGIN x := 72; y := 4; END;
        10 : BEGIN x := 72; y := 8; END;
        11 : BEGIN x := 72; y := 12; END;
        12 : BEGIN x := 72; y := 16; END;
        13 : BEGIN x := 72; y := 20; END;
        14 : BEGIN x := 64; y := 20; END;
        15 : BEGIN x := 56; y := 20; END;
        16 : BEGIN x := 48; y := 20; END;
        17 : BEGIN x := 40; y := 20; END;
        18 : BEGIN x := 32; y := 20; END;
        19 : BEGIN x := 24; y := 20; END;
        20 : BEGIN x := 16; y := 20; END;
        21 : BEGIN x := 8; y := 20; END;
        22 : BEGIN x := 8; y := 16; END;
        23 : BEGIN x := 8; y := 12; END;
        24 : BEGIN x := 16; y := 12; END;
        25 : BEGIN x := 24; y := 12; END;
        26 : BEGIN x := 32; y := 12; END;
        27 : BEGIN x := 40; y := 12; END;
        ELSE BEGIN x := 40; y := 12; END;

    END;

    IF (posicionDentroDeCasilla <> 1) THEN
    BEGIN

        dec(y); {Si no queremos mostrar el nombre de la casilla, nos colocamos
                en la linea del medio de la casilla}

        IF (posicionDentroDeCasilla = 2) THEN

            x := x + 2 {Si queremos mostrar la ficha del jugador 1, dejamos un
                        margen de 2 posiciones}

        ELSE

            x := x + 4; {Si queremos mostrar la ficha del jugador 2, dejamos un
                         margen de 4 posiciones, para que no tape la otra ficha}

    END;

    gotoxy(x, y); {Situamos el cursor en las coordenadas que hemos calculado}

END;


{------------------------------------------------------------------------------}


PROCEDURE muestraNombresCasillas(casillaPosada : integer;
                                 casillaCalavera : integer);
{Este procedimiento muestra los nombres de las casillas especiales, dando un
 color a cada una de ellas. El 1 que le pasamos al procedimiento indica que
 queremos mostrar el nombre de la casilla, para que situe el cursor en el lugar
 adecuado dentro de esta}


BEGIN

    colocaCursorEnCasilla(CASILLA_INICIAL, 1);
    textColor(COLOR_INICIO_FIN);
    write('INICIO');

    colocaCursorEnCasilla(CASILLA_FINAL, 1);
    write('JARDIN DE LA OCA');

    colocaCursorEnCasilla(PUENTE_1, 1);
    textColor(COLOR_PUENTES);
    write('PUENTE');

    colocaCursorEnCasilla(PUENTE_2, 1);
    write('PUENTE');

    colocaCursorEnCasilla(OCA_1, 1);
    textColor(COLOR_OCAS);
    write('OCA');

    colocaCursorEnCasilla(OCA_2, 1);
    write('OCA');

    colocaCursorEnCasilla(OCA_3, 1);
    write('OCA');

    colocaCursorEnCasilla(OCA_4, 1);
    write('OCA');

    colocaCursorEnCasilla(OCA_5, 1);
    write('OCA');

    colocaCursorEnCasilla(casillaPosada, 1);
    textColor(COLOR_POSADA);
    write('POSADA');

    colocaCursorEnCasilla(casillaCalavera, 1);
    textColor(COLOR_CALAVERA);
    write('CALAVE.');

END;


{------------------------------------------------------------------------------}


PROCEDURE muestraFichas(posicionJugador : integer;
                        posicionMaquina : integer);
{Este procedimiento muestra las fichas de los dos jugadores en el trablero. El 2
 y el 3 que le pasamos al procedimiento indican que queremos mostrar la ficha
 del jugador 1 o 2, respectivamente (un 1 indica que queremos mostrar el nombre
 de la casilla)}


BEGIN

    colocaCursorEnCasilla(posicionJugador, 2);
    textColor(COLOR_JUGADOR);
    write(FICHA_JUGADOR);

    colocaCursorEnCasilla(posicionMaquina, 3);
    textColor(COLOR_MAQUINA);
    write(FICHA_MAQUINA);

END;


{------------------------------------------------------------------------------}


PROCEDURE muestraSituacionActual(casillaPosada : integer;
                                 casillaCalavera : integer;
                                 posicionJugador : integer;
                                 posicionMaquina : integer);
{Este procedimiento muestra el tablero con los nombres de las casillas
especiales coloreados y las fichas de los dos jugadores, llamando a los
procedimientos correspondientes}


BEGIN

    muestraTablero;
    muestraNombresCasillas(casillaPosada, casillaCalavera);
    muestraFichas(posicionJugador, posicionMaquina);
    gotoxy(1, 22);
    textColor(COLOR_TEXTO);

END;


{------------------------------------------------------------------------------}


PROCEDURE caeEnCasilla (VAR casilla : integer;
                        VAR turnosRestantes : integer;
                        casillaPosada : integer;
                        casillaCalavera : integer);
{Este procedimiento llama al procedimiento correspondiente al caer en una
casilla}


BEGIN

    IF (casilla = CASILLA_FINAL) THEN

        ultimaCasilla(casilla, turnosRestantes)

    ELSE IF (casilla > CASILLA_FINAL) THEN
    BEGIN

        writeln((casilla - CASILLA_FINAL), ' casillas mas alla de la ultima casilla, se mueve para atras.');
        casilla := CASILLA_FINAL - (casilla - CASILLA_FINAL);
        write('Has caido en ');
        caeEnCasilla(casilla, turnosRestantes, casillaPosada, casillaCalavera);

    END

    ELSE IF (casilla = casillaPosada) THEN

        posada(casilla, turnosRestantes)

    ELSE IF (casilla = casillaCalavera) THEN

        calavera(casilla)

    ELSE IF ((casilla = PUENTE_1) OR (casilla = PUENTE_2)) THEN

        puente(casilla, turnosRestantes, casillaPosada)

    ELSE IF ((casilla = OCA_1) OR (casilla = OCA_2) OR (casilla = OCA_3) OR
             (casilla = OCA_4) OR (casilla = OCA_5)) THEN

        oca(casilla, turnosRestantes)

    ELSE

        writeln('la casilla ', casilla, '.');

END;


{------------------------------------------------------------------------------}


PROCEDURE pideCasillas(VAR casillaPosada : integer;
                       VAR casillaCalavera : integer);
{Este procedimiento pide la posicion de las casillas posada y calavera, y se
 asegura de que cumplan las reglas que pide el enunciado}


BEGIN

    clrscr;

    REPEAT

        write('Introduce la casilla que quieres que sea la posada: ');
        readln(casillaPosada);

        IF ((casillaPosada < CASILLA_INICIAL) OR
            (casillaPosada >= CASILLA_FINAL)) THEN
        BEGIN

            writeln('La casilla no puede ser menor que ', CASILLA_INICIAL,
                    ' ni mayor que ', CASILLA_FINAL-1, ', elige otra.');

        END;

        IF (casillaPosada <= PUENTE_2) THEN

            writeln('La posada debe estar despues del ultimo puente (casilla ',
                    PUENTE_2, '), elige otra.');

        IF ((casillaPosada = OCA_1) OR (casillaPosada = OCA_2) OR
            (casillaPosada = OCA_3) OR (casillaPosada = OCA_4) OR
            (casillaPosada = OCA_5)) THEN

            writeln('La casilla ', casillaPosada,
                    ' es una casilla especial, elige otra.');

    UNTIL ((casillaPosada > CASILLA_INICIAL) AND (casillaPosada < CASILLA_FINAL)
           AND (casillaPosada > PUENTE_2) AND (casillaPosada <> OCA_1) AND
           (casillaPosada <> OCA_2) AND (casillaPosada <> OCA_3) AND
           (casillaPosada <> OCA_4) AND (casillaPosada <> OCA_5));

    writeln('La posada se ha establecido en la casilla ', casillaPosada, '.');
    writeln;

    REPEAT

        write('Introduce la casilla que quieres que sea la calavera: ');
        readln(casillaCalavera);

        IF ((casillaCalavera < CASILLA_INICIAL) OR
            (casillaCalavera >= CASILLA_FINAL)) THEN
        BEGIN

            write('La casilla no puede ser menor que ', CASILLA_INICIAL,
                  ' ni mayor que ', CASILLA_FINAL-1, '.');

        END;

        IF ((casillaCalavera = OCA_1) OR (casillaCalavera = OCA_2) OR
            (casillaCalavera = OCA_3) OR (casillaCalavera = OCA_4) OR
            (casillaCalavera = OCA_5) OR (casillaCalavera = PUENTE_1) OR
            (casillaCalavera = PUENTE_2) OR
            (casillaCalavera = casillaPosada)) THEN

            writeln('La casilla ', casillaCalavera,
                    ' es una casilla especial, elige otra.');

    UNTIL ((casillaCalavera > CASILLA_INICIAL) AND
           (casillaCalavera < CASILLA_FINAL) AND (casillaCalavera <> PUENTE_1)
           AND (casillaCalavera <> PUENTE_2) AND (casillaCalavera <> OCA_1) AND
           (casillaCalavera <> OCA_2) AND (casillaCalavera <> OCA_3) AND
           (casillaCalavera <> OCA_4) AND (casillaCalavera <> OCA_5) AND
           (casillaCalavera <> casillaPosada));

    writeln('La calavera se ha establecido en la casilla ', casillaCalavera, '.');
    writeln;

    write('Pulsa la tecla intro para empezar el juego...');
    readln;

END;


{------------------------------------------------------------------------------}


PROCEDURE turno(jugador : integer;
                VAR turnosRestantes : integer;
                casillaPosada : integer;
                casillaCalavera : integer;
                VAR posicionJugador : integer;
                VAR posicionMaquina : integer);
{Este procedimiento simula un turno de un jugador}


VAR

    lanzamiento : integer;


BEGIN

    muestraSituacionActual(casillaPosada, casillaCalavera, posicionJugador, posicionMaquina);

    IF (jugador = 1) THEN
    BEGIN

        writeln('Es tu turno. Estas en la casilla ', posicionJugador,
                '.');
        write('Pulsa la tecla intro para lanzar el dado...');
    END

    ELSE
    BEGIN

        writeln('Es el turno de la maquina. Esta en la posicion ',
                 posicionMaquina, '.');
        write('Pulsa la tecla intro para continuar...');
    END;

    readln;
    lanzamiento := tirada;
    writeln;

    IF (jugador = 1) THEN
    BEGIN

        posicionJugador := posicionJugador + lanzamiento;
        muestraSituacionActual(casillaPosada, casillaCalavera, posicionJugador, posicionMaquina);
        writeln('Has sacado un ', lanzamiento, '.');
        write('Has caido en ');
        caeEnCasilla(posicionJugador, turnosRestantes, casillaPosada, casillaCalavera);

    END

    ELSE
    BEGIN

        posicionMaquina := posicionMaquina + lanzamiento;
        muestraSituacionActual(casillaPosada, casillaCalavera, posicionJugador, posicionMaquina);
        writeln('La maquina ha sacado un ', lanzamiento, '.');
        write('Ha caido en ');
        caeEnCasilla(posicionMaquina, turnosRestantes, casillaPosada, casillaCalavera);

    END;

    write('Pulsa la tecla intro para continuar...');
    readln;

END;


{------------------------------------------------------------------------------}


PROCEDURE final(posicionJugador : integer);
{Este procedimiento muestra el mensaje final del juego}


BEGIN

    clrscr;

    IF (posicionJugador = CASILLA_FINAL) THEN

        writeln('Has ganado')

    ELSE

        writeln('La maquina ha ganado');

    writeln;

END;


{------------------------------------------------------------------------------}


PROCEDURE juego;
{Este procedimiento contiene el bucle principal del juego}


VAR

    {Estas casillas las elige el usuario, por eso son variables}
    casillaPosada : integer;
    casillaCalavera : integer;

    {Las posiciones de los dos jugadores en el tablero}
    posicionJugador : integer;
    posicionMaquina : integer;

    {Turnos que le quedan al jugador actual}
    turnosRestantes : integer;

    {Si quiere volver a jugar o no}
    respuesta : char;


BEGIN

    REPEAT

        {Inicializamos las variables}
        pideCasillas(casillaPosada, casillaCalavera);
        posicionJugador := CASILLA_INICIAL;
        posicionMaquina := CASILLA_INICIAL;
        turnosRestantes := 0;

        REPEAT

            {Si el jugador anterior se quedo sin turnos}
            IF (turnosRestantes = 0) THEN

                turnosRestantes := 1
            {Si el jugador anterior tiene -1 turnos es que da al otro uno extra}
            ELSE

                turnosRestantes := 2;

            REPEAT

                turno(1, turnosRestantes, casillaPosada, casillaCalavera, posicionJugador, posicionMaquina);
                dec(turnosRestantes);

            UNTIL ((turnosRestantes <= 0) OR (posicionJugador = CASILLA_FINAL));

            IF (posicionJugador <> CASILLA_FINAL) THEN
            BEGIN

                IF (turnosRestantes = 0) THEN

                    turnosRestantes := 1

                ELSE

                    turnosRestantes := 2;

                REPEAT

                    turno(2, turnosRestantes, casillaPosada, casillaCalavera, posicionJugador, posicionMaquina);
                    dec(turnosRestantes);

                UNTIL ((turnosRestantes <= 0) OR (posicionMaquina = CASILLA_FINAL));
            END;

        UNTIL ((posicionJugador = CASILLA_FINAL) OR
               (posicionMaquina = CASILLA_FINAL));

        final(posicionJugador);

        REPEAT

            write('Quieres volver a jugar? (S/N): ');
            readln(respuesta);
            respuesta := upcase(respuesta);

        UNTIL ((respuesta = 'S') OR (respuesta = 'N'));

    UNTIL (respuesta = 'N');

END;


{------------------------------------------------------------------------------}


BEGIN {Programa principal}

    randomize; {Para generar numeros pseudoaleatorios, debemos llamar a este
                procedimiento antes de hacer cualquier random, si no los numeros
                generados siempre seguiran la misma secuencia y todas las
                partidas seran iguales}
    juego;

END.
