
program juegoDeLaOca;

uses crt;

(* --------------------------------------------
Juego de La oca
-----------------------------------------------
FUNCIONES Y PROCEDIMIENTOS
* TirarDado: Devuelve un numero aleatorio entre
             uno y seis

* MoverFicha(Jugador): mueve la
             ficha del jugador tantas casillas
             como marque numero

* JugarPartida(Jugador,tablero): Procedimiento
             que incluye a todo el juego

* Presentacion: Procedimiento con logo de la oca

* BuscarPosada: A partir del tablero te
				devuelve la posicion de la
				posada

* siguienteOca: A partir del tablero y la casilla,
                te devuelve la posicion de la siguiente oca.
                Si es la ultima, te devuelve la misma

* iniciarTablero: Inicia todas las casillas del tablero incluidas las
                  propias de usuario

* inscribirJugador: Inicia los valores de
                    jugador 1 (Persona) y jugador 2 (Ordenador)

* pintaOca: Pinta el tablero de la 
            oca

* moverFicha: en repetir, true implica que
              el otro jugador tira dos veces.
              A partir del tablero y el jugador,
              se mueve ficha con ayuuda de las funciones anteriores

* cambiarTurno: con turno 1, cambia a 2
                y con 2 a 1

* jugarPartida: Procedimiento general
               que gestiona la partida

-----------------------------------------------
OBSERVACIONES
* Empieza tirando jugador1
* Los mensajes de tira otra vez implica no ensesear
  el tablero por pantalla por claridad.
* El jugador Amarillo es el usuario.
* Se dispondra de lanzador para usuario y para
  ordenador.
* Solo se aceptan los 20 primeros caracteres de
  nombres
----------------------------------------------*)

(*----------------------------------------------*)
(* Declaracion de Tipos de Datos                *)
(*----------------------------------------------*)
type

    tipoCasillas = (OCA,PUENTE,POSADA,CALAVERA,JARDIN,VACIA);

type tpJugador = RECORD
     nombre:string[20];
     casilla:integer;
end;

type jugadores = array[1..2] of tpJugador;

type tablero = array[1..27] of tipoCasillas;
(*----------------------------------------------*)


(*----------------------------------------------*)
(* Funcion TirarDado: Devuelve un numero booleano
                      entre el 1 y el 6.	*)
(*----------------------------------------------*)
function tirarDado: integer;
begin
    randomize;
    tirarDado:=random(5)+1;
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Presentacion: Procedimiento con logo de la oca *)
(*----------------------------------------------*)
procedure Presentacion;

begin
textbackground(15);
textcolor(5);
writeln('                ,;MMMM..                                                       ');
writeln('             ,;:MM"MMMMM.                                                      ');
writeln('          ,;.MM::M.MMMMMM:                                                     '); 
writeln('          ""::.;MMMMMMMMM                                                      ');
writeln('                 "`""MMMMM;                                                    ');
writeln('                     `:MMMM.                                                   ');
writeln('                      `MMMM;                                                   ');
writeln('                       :MMMM;.                                                 '); 
writeln('                        MMMMMM;...                                             '); 
writeln('                        MMMMMMMMMMMMM;.;..                                     '); 
writeln('                        MMMMMMMMMMMMMMMMMMM...                                 '); 
writeln('                        MMMMMM:MMMMMMMMMMMMMMM;...       ..:                   '); 
writeln('                        MMMMMM;MMMMMMMMMMMMM:MMMMMMM:MMMM:M                    ');
writeln('                        :MMMMMM:MMMMMMMMMMMMMMM.:::;:::;;:`                    ');
writeln('                        `:MMMMMMM:MMMM:;MM:M;.MMM:`;::M:`                      ');
writeln('                         `:MMMMMM;M;;MM;::M;;::::;MM:""                        ');
writeln('                           `MMMMMMMM;M;:::MMMMMMMMMM"                          ');
writeln('                            ``MMMMMMMMMMMMMMMMMMMMM"                           ');
writeln('                               `:MMMMMMMMMMMMMMMM"`                            ');
writeln('                                 ``:MMMMMMMMMMM"`                              ');
writeln('              - Juego de la Oca -  `:MMMMMM""`                                 ');
writeln('                                       .                                       ');
writeln('                                      ::                                       '); 
write('                                 ,..;.M`                                       ');
textbackground(0);
textcolor(15);
readln;clrscr;
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Funcion BuscarPosada: A partir del tablero te
   devuelve la posicion de la
   posada					*)
(*----------------------------------------------*)
function buscarPosada(t:tablero): integer;
var encontrado:boolean;
    i:integer;
begin
     encontrado:=false;
     i:=1;
     while ((not encontrado) and (i<27)) do
     begin
           if(t[i]=POSADA) then
           begin
           buscarPosada:=i;
           encontrado:=true;
           end
           else buscarPosada:=6;
           i:=i+1;
     end;
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Funcion siguienteOca: a partir del tablero y la casilla,
   te devuelve la posicion de la siguiente oca.
   Si es la ultima, te devuelve la misma.       *)
(*----------------------------------------------*)
function siguienteOca(n:integer;t:tablero): integer;
var encontrado:boolean;
    i:integer;
begin
     encontrado:=false;
     i:=n+1;
     if n < 23 then begin
     while not encontrado do
     begin
           if(t[i]=OCA)then
           begin
           siguienteOca:=i;
           encontrado:=true;
           end;
           i:=i+1;
     end;
     end
     else siguienteOca:=n
     -1;
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Funcion iniciarTablero: Inicia todas las casillas
                           del tablero incluidas las
                           propias de usuario.	*)
(*----------------------------------------------*)
procedure iniciarTablero(var Tab:tablero);
var i,num: integer;
begin
    for i:=1 to 27 do
    begin
        Tab[i]:=VACIA;
    end;

        Tab[5]:=OCA;
        Tab[9]:=OCA;
        Tab[14]:=OCA;
        Tab[18]:=OCA;
        Tab[23]:=OCA;
        Tab[6]:=PUENTE;
        Tab[12]:=PUENTE;
        Tab[27]:=JARDIN;
        writeln('---------------------------------------');
        writeln('Las casillas 5, 9, 14, 18 y 23 son Oca,');
        writeln('las casillas 6 y 12 son puente, y la 27');
        writeln('es jardin. Si coloca las casillas de ca');
        writeln('lavera o posada en alguna de ellas, pu-');
        writeln('ede provocar que el juego pierda algun-');
        writeln('a regla. Tenga cuidado con su eleccion ');
        writeln('---------------------------------------');
        write('Casilla de Calavera: ');
        readln(num);
        while ((num>26) or (num<1)) do
        begin
        write('Error, el numero es incorrecto, repita: ');
        readln(num);
        end;
        Tab[num]:=CALAVERA;
        write('Casilla de Posada: ');
        readln(num);
        while ((num>26) or (num<1)) do
        begin
        write('Error, el numero es incorrecto, repita: ');
        readln(num);
        end;
        Tab[num]:=POSADA;
end;
(*---------------------------------------------*)

(*----------------------------------------------*)
(*Procedimiento pintaOca: Pinta el tablero de la oca *)
(*----------------------------------------------*)
procedure pintaOca(jugador: jugadores);
begin
gotoxy(1,4);
writeln('+----+----+----+----+----+----+');
writeln('|14  |13  |12  |11  |10  |9   |');
writeln('|    |    |    |    |    |    |');
writeln('+----+----+----+----+----+----+');
writeln('|15  |26  |25  |24  |23  |8   |');
writeln('|    |    |    |    |    |    |');
writeln('+----+----+----+----+----+----+');
writeln('|16  |27 O    C    A|22  |7   |');
writeln('|    |              |    |    |');
writeln('+----+----+----+----+----+----+');
writeln('|17  |18  |19  |20  |21  |6   |');
writeln('|    |    |    |    |    |    |');
writeln('|----+----+----+----+----+----+');
writeln('|0   |1   |2   |3   |4   |5   |');
writeln('|    |    |    |    |    |    |');
writeln('+----+----+----+----+----+----+');
case (jugador[1].casilla) of
0:gotoxy(2,18);
1:gotoxy(7,18);
2:gotoxy(12,18);
3:gotoxy(17,18);
4:gotoxy(22,18);
5:gotoxy(27,18);
6:gotoxy(27,15);
7:gotoxy(27,12);
8:gotoxy(27,9);
9:gotoxy(27,6);
10:gotoxy(22,6);
11:gotoxy(17,6);
12:gotoxy(12,6);
13:gotoxy(7,6);
14:gotoxy(2,6);
15:gotoxy(2,9);
16:gotoxy(2,12);
17:gotoxy(2,15);
18:gotoxy(7,15);
19:gotoxy(12,15);
20:gotoxy(17,15);
21:gotoxy(22,15);
22:gotoxy(22,12);
23:gotoxy(22,9);
24:gotoxy(17,9);
25:gotoxy(12,9);
26:gotoxy(7,9);
27:gotoxy(12,12);
end;
textcolor(14);
write('X');
case (jugador[2].casilla) of
0:gotoxy(3,18);
1:gotoxy(8,18);
2:gotoxy(13,18);
3:gotoxy(18,18);
4:gotoxy(23,18);
5:gotoxy(28,18);
6:gotoxy(28,15);
7:gotoxy(28,12);
8:gotoxy(28,9);
9:gotoxy(28,6);
10:gotoxy(23,6);
11:gotoxy(18,6);
12:gotoxy(13,6);
13:gotoxy(8,6);
14:gotoxy(3,6);
15:gotoxy(3,9);
16:gotoxy(3,12);
17:gotoxy(3,15);
18:gotoxy(8,15);
19:gotoxy(13,15);
20:gotoxy(18,15);
21:gotoxy(23,15);
22:gotoxy(23,12);
23:gotoxy(23,9);
24:gotoxy(18,9);
25:gotoxy(13,9);
26:gotoxy(8,9);
27:gotoxy(13,12);
end;
textcolor(3);
write('X');
gotoxy(1,22);
textcolor(15);
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Proc. moverFicha: en repetir, true implica que el otro jugador
                     tira dos veces.A partir del tablero y el jugador,
                     se mueve ficha con ayuda de las funciones anteriores.*)
(*----------------------------------------------*)
procedure moverFicha(var jugador:tpJugador;t:tablero;var repetir:boolean);
var num: integer;
    tiraOtra: boolean;
    casillaAux: tipoCasillas;
begin
     tiraOtra:=true;
     while tiraOtra do
     begin
        tiraOtra:=false;
            num:=tirarDado;
            write('El jugador ');
            write(jugador.nombre);
            write(' en posicion ');
            write(jugador.casilla);
            write(' ha sacado ');
            writeln(num);
         (*Por defecto...*)
          repetir:=false;
          if(jugador.casilla+num)<28 then
          begin
          (*No llega al jardin*)
          casillaAux:=t[jugador.casilla+num];
          case casillaAux of
                VACIA : begin
                jugador.casilla:=jugador.casilla+num;
                write('Cae en '); write(jugador.casilla);
                writeln(' vacio');
                end;
                PUENTE: begin
                write('Cae en '); write(jugador.casilla+num);

                jugador.casilla:=buscarPosada(t);
                repetir:=true;
                write(' y va a ');write(jugador.casilla);
                writeln(', puente y pierde turno');
                end;
                POSADA: begin
                jugador.casilla:=jugador.casilla+num;
                repetir:=true;
                write('Cae en '); write(jugador.casilla);
                writeln(' posada y pierde turno');
                end;
                CALAVERA: begin
                write('Cae en '); write(jugador.casilla);
                jugador.casilla:=1;
                writeln(' calavera, y a la casilla 1');
                end;
                OCA:    begin
                write('Cae en '); write(jugador.casilla+num);
                jugador.casilla:=siguienteOca(jugador.casilla+num,t);
                tiraOtra:=true;
                write(' que es oca y salta a '); write(jugador.casilla);
                writeln('. Tira otra vez(intro);!');readln;clrscr;end;
                JARDIN: begin
                jugador.casilla:=jugador.casilla+num;
                write('Cae en '); write(jugador.casilla);
                writeln(' Jardin'); end;
          end;end
          (*Se pasa del jardin*)
          else
          begin
          jugador.casilla:=(54-jugador.casilla-num); (*27-((pos+num)-27)*)
          write('Cae en '); writeln(jugador.casilla);
          end;
          writeln('---------------------------------------');
         end;

end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Procedimiento inscribirJugador: Inicia los valores
                                   de jugador 1 (Persona)
                                   y jugador 2 (Ordenador)*)
(*----------------------------------------------*)
procedure inscribirJugador(var Jug:jugadores);
begin
         write('Nombre del jugador: ');
         readln(Jug[1].nombre);
         Jug[1].casilla:=0;
         Jug[2].casilla:=0;
         Jug[2].nombre:='computer';
end;
(*----------------------------------------------*)

(*----------------------------------------------*)
(* Procedimiento cambiarTurno: con turno 1, cambia a 2
                               y con 2 a 1	*)
(*----------------------------------------------*)
procedure cambiarTurno(var turno:integer);
begin
     if turno=1 then
        turno:=2
     else
        turno:=1;
end;
(*----------------------------------------------*)


(*----------------------------------------------*)
(* Procedimiento jugarPartida: Procedimiento general
                               que gestiona la partida.*)
(*----------------------------------------------*)
procedure jugarPartida;
var turno: integer;
    tab: tablero;
    jug: jugadores;
    finalizado,repetir: boolean;
    
begin
         (*Inicializamos las variables*)
         finalizado:=false;
         turno:=1;
         iniciarTablero(tab);
         inscribirJugador(jug);
         writeln('Jugadores Inscritos');
         writeln('---------------------------------------');
         while not finalizado do
         (*Bucle primero para realizarse hasta
         que termine el juego*)
         begin  
        (*Contenido de cada movimiento*)
        (*Solo se pueden acumular dos*)
         if turno=1 then
               begin
                write('Pulsa tecla para tirar'); readln;;
               end
               else
               begin
                  writeln('Lanzado dado de Computer');
                  delay(1000);
                  write('Dado Lanzado! (Tecla para continuar)');
                  readln;
               end;
               clrscr;
               repetir:=false;
               moverFicha(jug[turno],tab,repetir);
               pintaoca(jug);
               if repetir then
               begin
               cambiarTurno(turno);
                 if turno=1 then
                 begin
                      write('Pulsa tecla para tirar');pintaoca(jug); readln;
                 end
                 else
                 begin
                 writeln('Lanzado dado de Computer');
                  delay(871);
                  write('Dado Lanzado!');
                  delay(490);pintaoca(jug);readln;
                 end;
               moverFicha(jug[turno],tab,repetir);
               cambiarTurno(turno);
               end;
               if jug[turno].casilla=27 then finalizado:=true;
               cambiarTurno(turno);
         end;
     cambiarTurno(turno);(*Para saber quien ha ganado...*)
     write('La Oca ha finalizado, ganador: ');writeln(jug[turno].nombre); readln;
end;
(*----------------------------------------------*)

Begin
     writeln('Juego de La Oca (Pulse una tecla para comenzar)');
     presentacion;
     jugarPartida;
     writeln('Gracias por usar nuestra Oca');
     readln;

end.
